package celery.engine.fsm;

import java.util.HashMap;

public class FSM {

	protected HashMap<String, FSMState> states_ = new HashMap<String, FSMState>();
	protected FSMState start_;

	protected FSMState curstate_;

	public FSM(FSMState start) {
		start_ = start;
		this.addState(start);
		curstate_ = start;
	}

	public final void addState(FSMState state) {
		states_.put(state.name(), state);
	}

	public final FSMState state(String name) {
		return states_.get(name);
	}

	public final void update() {
		for (FSMLink link : curstate_.links()) {
			if (link.checkCondition()) {
				curstate_ = link.next();
				break;
			}
		}

		curstate_.run();
	}
}
