package celery.engine.fsm;

import java.util.ArrayList;

public abstract class FSMState {

	protected String name_;
	protected ArrayList<FSMLink> links_;

	public FSMState(String name) {
		name_ = name;
		links_ = new ArrayList<FSMLink>();
	}

	public abstract void run();

	public final String name() {
		return name_;
	}

	public void addLink(FSMLink link) {
		links_.add(link);
	}

	public ArrayList<FSMLink> links() {
		return links_;
	}
}
