package celery.engine.graphics.animation;

import celery.engine.Engine;
import celery.engine.graphics.Animation;
import celery.engine.graphics.SceneEntity;

public class RotationAnimation extends Animation {

	/**
	 * Rotation animation constructor. The SceneEntity is the entity to rotate,
	 * and dTheta is the amount to rotate (in degrees per second).
	 * 
	 * @param e
	 * @param dtheta
	 */

	protected float curTheta_ = 0.f;
	protected float dTheta_;
	protected long maxTime_;

	public RotationAnimation(SceneEntity e, float dtheta, long length) {
		super(e);
		dTheta_ = dtheta;
		maxTime_ = length;
	}

	@Override
	public void runTimeStep() {
		if (!isRunning_)
			return;

		long dt = Engine.instance().elapsedTime() - prevTime_;
		entity_.transform().theta += dt / 1000.f * dTheta_;

		super.runTimeStep();
	}

	@Override
	public void reset(boolean loop) {
		// TODO Auto-generated method stub

	}

	@Override
	public boolean isFinished() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	protected void onAnimationFinished() {
		// TODO Auto-generated method stub

	}

}
