package celery.engine.graphics.entities;

import android.graphics.Canvas;
import android.graphics.Rect;
import celery.engine.Engine;
import celery.engine.graphics.SceneEntity;
import celery.engine.graphics.SceneMaterial;
import celery.engine.graphics.Viewport;
import celery.engine.inputhandlers.TouchInputHandler;
import celery.engine.utils.math.Transform;
import celery.engine.utils.math.Vec2F;
import celery.engine.utils.math.Vec4F;

public class Button extends SceneEntity {

	protected SceneMaterial buttonMat_, textMat_;
	protected String text_;
	protected Rectangle rect_;
	protected Rect bounds_;

	public Button(String str, Transform tfo, SceneMaterial textMat,
			SceneMaterial buttonMat, TouchInputHandler tHdl) {
		super(EntityType.POLYGON, tfo, buttonMat, tHdl);
		buttonMat_ = buttonMat;
		textMat_ = textMat;
		text_ = str;
		rect_ = new Rectangle(tfo, buttonMat, tHdl);
		bounds_ = new Rect();

		textMat_.paint.getTextBounds(text_, 0, text_.length(), bounds_);
		System.out.println(bounds_.left + ", " + bounds_.right + ", "
				+ bounds_.top + ", " + bounds_.bottom);
	}

	public void setText(String txt) {
		text_ = txt;
	}

	@Override
	public Vec4F getAABB() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public boolean isInBounds(Vec2F coord) {
		return rect_.isInBounds(coord);
	}

	@Override
	public void draw(Canvas c, Engine e, Viewport v, Vec4F bounds) {
		rect_.draw(c, e, v, bounds);
		c.save();
		c.scale(1 / rect_.transform().scale.x, 1 / rect_.transform().scale.y);
		textMat_.paint.setTextSize(rect_.transform().scale.y / 2.5f);
		c.drawText(text_, -0.1f, 0.03f, textMat_.paint);
		c.restore();
	}

	@Override
	public GeometryData geometryData() {
		// TODO Auto-generated method stub
		return null;
	}

}
