package celery.engine.graphics.entities;

import android.graphics.Canvas;
import celery.engine.Engine;
import celery.engine.graphics.SceneEntity;
import celery.engine.graphics.SceneMaterial;
import celery.engine.graphics.Viewport;
import celery.engine.inputhandlers.TouchInputHandler;
import celery.engine.utils.Utils;
import celery.engine.utils.math.Transform;
import celery.engine.utils.math.Vec2F;
import celery.engine.utils.math.Vec3F;
import celery.engine.utils.math.Vec4F;

public class Circle extends SceneEntity {

	public Circle(Transform tfo, SceneMaterial sm, TouchInputHandler hdl) {
		super(EntityType.CIRCLE, new Transform(tfo), sm, hdl);
		transfo_.scale.y = transfo_.scale.x;
		Vec3F[] cs = new Vec3F[1];
		cs[0] = new Vec3F(0.f, 0.f, 0.5f);
		geoDataModel_ = new GeometryData(null, cs);
		geoDataWorld_ = new GeometryData(null, cs);
	}

	@Override
	public Vec4F getAABB() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public boolean isInBounds(Vec2F coord) {

		final Vec2F model = Utils.toModelSpace(transfo_, coord);
		return model.length2() <= 0.25f;
	}

	@Override
	public void draw(Canvas c, Engine e, Viewport v, Vec4F bounds) {
		// float radius = (bounds.z - bounds.x) * 0.5f;
		c.drawCircle(0.f, 0.f, 0.5f, material_.paint);
	}

	@Override
	public GeometryData geometryData() {
		return geoDataModel_.transform(transfo_, geoDataWorld_);
	}

}
