package celery.engine.graphics.entities;

import java.util.ArrayList;

import celery.engine.graphics.SceneEntity;
import celery.engine.updatehandlers.PhysicsConstraint;
import celery.engine.utils.math.Vec2F;

public class PhysicsEntity {

	public PhysicsEntity(SceneEntity e, Vec2F a) {
		acceleration = new Vec2F(a);
		entity = e;
		previousPosition = new Vec2F(e.transform().translate);
		// currentPosition = new Vec2F(e.transform().translate);
	}

	public PhysicsEntity(SceneEntity e, Vec2F a, Vec2F v0) {
		acceleration = new Vec2F(a);
		entity = e;
		previousPosition = new Vec2F(e.transform().translate).sub(v0);
		// currentPosition = new Vec2F(e.transform().translate);
	}

	public void setVelocity(Vec2F v) {
		previousPosition.set(entity.transform().translate).subEq(v);
	}

	public Vec2F velocity() {
		return tmp.set(entity.transform().translate).subEq(previousPosition);
	}

	public ArrayList<PhysicsConstraint> constraints = new ArrayList<PhysicsConstraint>();
	private final Vec2F tmp = new Vec2F();
	public SceneEntity entity;
	public Vec2F previousPosition;
	// public Vec2F currentPosition;
	public Vec2F acceleration;
	public Vec2F accelAccum = new Vec2F();
}
