package celery.engine.graphics.entities;

import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Rect;
import android.graphics.RectF;
import celery.engine.Engine;
import celery.engine.graphics.SceneEntity;
import celery.engine.graphics.SceneMaterial;
import celery.engine.graphics.Viewport;
import celery.engine.inputhandlers.TouchInputHandler;
import celery.engine.managers.MaterialManager;
import celery.engine.utils.Utils;
import celery.engine.utils.math.Transform;
import celery.engine.utils.math.Vec2F;
import celery.engine.utils.math.Vec4F;

public class Sprite extends SceneEntity {

	protected Bitmap bitmap_;
	protected Rect sourceRect_;
	protected float imageRatio_;

	public Sprite(Bitmap b, Transform tfo, TouchInputHandler hdl) {
		super(EntityType.POLYGON, tfo, null, hdl);
		bitmap_ = b;
		sourceRect_ = new Rect(0, 0, b.getWidth(), b.getHeight());
		imageRatio_ = Math.max(b.getWidth(), b.getHeight());// //b.getWidth() /
		if (MaterialManager.instance().material("aa") == null) {
			Paint p = new Paint();
			p.setAntiAlias(true);
			SceneMaterial.createManagedMaterial("aa", p);
		}

	}

	@Override
	public Vec4F getAABB() {
		// TODO Auto-generated method stub
		return null;
	}

	public final void setSrcRect(Rect srcRect) {
		sourceRect_ = srcRect;
	}

	public final Bitmap bitmap() {
		return bitmap_;
	}

	@Override
	public void draw(Canvas c, Engine e, Viewport v, Vec4F bounds) {
		// float w = bounds.z - bounds.x;
		// float h = bounds.w - bounds.y;
		// float r1 = w / bitmap_.getWidth();
		// float r2 = h / bitmap_.getHeight();
		// float r = Math.min(r1, r2);
		// w = bitmap_.getWidth() * r;
		// h = bitmap_.getHeight() * r;
		float w = sourceRect_.width();
		float h = sourceRect_.height();
		float w1 = Math.max(1.f, w / h);
		float h1 = Math.max(1.f, h / w);
		RectF dst = new RectF(-0.5f * w1, -0.5f * h1, w1 - 0.5f * w1, h1 - 0.5f
				* h1);
		c.drawBitmap(bitmap_, sourceRect_, dst, MaterialManager.instance()
				.material("aa").paint);
	}

	@Override
	public boolean isInBounds(Vec2F coord) {
		final Vec2F model = Utils.toModelSpace(transfo_, coord);
		// System.out.println(coord + "-->" + model);
		return model.x >= -0.5f && model.y >= -0.5f && model.x <= 0.5f
				&& model.y <= 0.5f;
		// Vec2F coordM = coord.rotateCW(center_, -transfo_.theta);
		//
		// return coordM.x < transfo_.translate.x + transfo_.scale.x
		// && coordM.y < transfo_.translate.y + transfo_.scale.y
		// && coordM.x > transfo_.translate.x
		// && coordM.y > transfo_.translate.y;
	}

	@Override
	public GeometryData geometryData() {
		// TODO Auto-generated method stub
		return null;
	}

}
