package celery.engine.graphics.entities;

import android.graphics.Canvas;
import celery.engine.Engine;
import celery.engine.graphics.SceneEntity;
import celery.engine.graphics.SceneMaterial;
import celery.engine.graphics.Viewport;
import celery.engine.inputhandlers.TouchInputHandler;
import celery.engine.utils.math.Transform;
import celery.engine.utils.math.Vec2F;
import celery.engine.utils.math.Vec4F;

public class TextEntity extends SceneEntity {

	protected String text_;

	public TextEntity(String text, Transform tfo, SceneMaterial sm,
			TouchInputHandler hdl) {
		super(EntityType.POLYGON, tfo, sm, hdl);
		text_ = text;
		// this.setTransform(tfo);
	}

	public void setText(String text) {
		text_ = text;
	}

	@Override
	public Vec4F getAABB() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public boolean isInBounds(Vec2F coord) {
		Vec2F coordM = coord.rotateCW(center_, -transfo_.theta);
		return coordM.x < transfo_.translate.x + transfo_.scale.x
				&& coordM.y < transfo_.translate.y + transfo_.scale.y
				&& coordM.x > transfo_.translate.x
				&& coordM.y > transfo_.translate.y;
	}

	@Override
	public void draw(Canvas c, Engine e, Viewport v, Vec4F bounds) {
		material_.paint.setTextSize(.25f);
		c.drawText(text_, 0, 0, material_.paint);
		// c.drawText(text_, bounds.x, bounds.y, material_.paint);
	}

	@Override
	public void computeCenter(Viewport v) {
		/*
		 * if (text_ == null || v == null) return; Rect bounds = new Rect();
		 * material_.paint.getTextBounds(text_, 0, text_.length(), bounds);
		 * center_ = new Vec2F(bounds.width() / 2, bounds.height() / 2); center_
		 * = v.screenToVirtual(center_).add(transfo_.translate);
		 */
	}

	@Override
	public GeometryData geometryData() {
		// TODO Auto-generated method stub
		return null;
	}

}
