package celery.engine.graphics.entities;

import android.graphics.Canvas;
import android.graphics.Path;
import celery.engine.Engine;
import celery.engine.graphics.SceneMaterial;
import celery.engine.graphics.Viewport;
import celery.engine.inputhandlers.TouchInputHandler;
import celery.engine.utils.Utils;
import celery.engine.utils.math.Transform;
import celery.engine.utils.math.Vec2F;
import celery.engine.utils.math.Vec4F;

public class Triangle extends Polygon {

	protected Path trianglePath_;

	public Triangle(Transform tfo, SceneMaterial sm, TouchInputHandler hdl) {
		super(tfo, sm, hdl);
		trianglePath_ = new Path();

		Vec2F[][] pointList_ = new Vec2F[1][];
		pointList_[0] = new Vec2F[3];
		pointList_[0][0] = new Vec2F(0.f, -.25f);
		pointList_[0][1] = new Vec2F(0.5f, .25f);
		pointList_[0][2] = new Vec2F(-0.5f, .25f);
		geoDataModel_ = new GeometryData(pointList_, null);
		geoDataWorld_ = new GeometryData(pointList_, null);
		trianglePath_.reset();
		trianglePath_.moveTo(0.0f, -0.25f);
		trianglePath_.lineTo(0.5f, 0.25f);
		trianglePath_.lineTo(-0.5f, 0.25f);
		trianglePath_.lineTo(0.0f, -0.25f);
	}

	protected void createTrianglePath() {
		trianglePath_.reset();
	}

	@Override
	public Vec4F getAABB() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public boolean isInBounds(Vec2F coord) {
		final Vec2F model = Utils.toModelSpace(transfo_, coord);
		// System.out.println(model);
		return model.x >= 0.0f && model.y >= 0.0f && model.x <= 1.0f
				&& model.y <= 1.0f && 1.0f - model.y <= 1.0f - model.x;
	}

	@Override
	public void draw(Canvas c, Engine e, Viewport v, Vec4F bounds) {

		c.drawPath(trianglePath_, material_.paint);
	}

	@Override
	public GeometryData geometryData() {
		return geoDataModel_.transform(transfo_, geoDataWorld_);

	}

}
