package celery.engine.managers;

import java.util.HashMap;

import android.app.Activity;
import android.media.SoundPool;

public class AudioManager {

	protected HashMap<String, Integer> mediaMap_;
	protected static AudioManager s_instance_;
	protected SoundPool sp_;

	protected AudioManager() {
		mediaMap_ = new HashMap<String, Integer>();
		sp_ = new SoundPool(32, android.media.AudioManager.STREAM_MUSIC, 0);
	}

	public static void init() {
		s_instance_ = new AudioManager();
	}

	public static AudioManager instance() {
		return s_instance_;
	}

	// public MediaPlayer stream(String name) {
	// return mediaMap_.get(name);
	// }

	public void play(String name) {

		sp_.play(mediaMap_.get(name), 1.f, 1.f, 1, 0, 1.f);
	}

	// public static MediaPlayer createStream(int id, Activity a) {
	//
	// return MediaPlayer.create(a, id);
	// }

	/**
	 * Create an audio stream and store it for future use.
	 * 
	 * @param name
	 * @param id
	 * @return
	 */
	public void createStream(String name, int id, Activity a) {
		mediaMap_.put(name, sp_.load(a, id, 1));
		;
	}
}
