package celery.engine.managers;

import java.util.HashMap;

import celery.engine.Engine;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;

/*
 * Singleton class owned by the engine activity.
 */

public class BitmapManager {
	protected static BitmapManager instance = null;
	protected HashMap<String, Bitmap> drawables_;

	private BitmapManager() {
		drawables_ = new HashMap<String, Bitmap>();
	}

	public void loadBitmap(String name, int id) {

		drawables_.put(
				name,
				BitmapFactory.decodeResource(Engine.instance().drawHandler()
						.getContext().getResources(), id));
	}

	public Bitmap bitmap(String name) {
		return drawables_.get(name);
	}

	public static void init() {
		instance = new BitmapManager();
	}

	public static BitmapManager instance() {
		return instance;
	}
}
