package celery.engine.managers;

import java.util.HashMap;

import celery.engine.Engine;
import celery.engine.graphics.SceneMaterial;


/**
 * Allows materials to be shared between different scene entities
 * 
 * @author psastras
 * 
 */
public class MaterialManager {

	protected HashMap<String, SceneMaterial> materials_;

	private MaterialManager() {
		materials_ = new HashMap<String, SceneMaterial>();
	}

	public void addMaterial(String matName, SceneMaterial mat) {
		mat.paint
				.setAntiAlias(Engine.instance().drawHandler().settings().antialiasing);
		materials_.put(matName, mat);
	}

	public SceneMaterial material(String matname) {
		return materials_.get(matname);
	}

	public SceneMaterial removeMaterial(String matname) {
		return materials_.remove(matname);
	}

	private static class MaterialManagerInstance {
		public static MaterialManager instance = null;
	}

	public static void init() {
		MaterialManagerInstance.instance = new MaterialManager();
	}

	public static MaterialManager instance() {
		return MaterialManagerInstance.instance;
	}
}
