package celery.engine.updatehandlers;

import celery.engine.graphics.entities.PhysicsEntity;
import celery.engine.utils.math.Vec2F;
import celery.engine.utils.math.Vec4F;

public class BoxConstraint implements PhysicsConstraint {

	protected Vec4F bounds_;

	public BoxConstraint(Vec4F Box) {
		bounds_ = new Vec4F(Box);
	}

	@Override
	public boolean applyConstraint(PhysicsEntity e, float timeElapsed) {
		boolean toReturn = true;
		// e.previousPosition = new Vec2F(e.entity.transform().translate);
		Vec2F pos = e.entity.transform().translate;
		if (pos.x < bounds_.x) {
			e.previousPosition.set(e.entity.transform().translate);
			pos.x = bounds_.x;
			toReturn = false;
		} else if (pos.x > bounds_.z) {
			e.previousPosition.set(e.entity.transform().translate);
			pos.x = bounds_.z;
			toReturn = false;
		}

		if (pos.y < bounds_.y) {
			e.previousPosition.set(e.entity.transform().translate);
			pos.y = bounds_.y;
			toReturn = false;
		} else if (pos.y > bounds_.w) {
			e.previousPosition.set(e.entity.transform().translate);
			pos.y = bounds_.w;

			toReturn = false;
		}

		return toReturn;
	}

}
