package celery.engine.updatehandlers;

import celery.engine.graphics.SceneEntity;
import celery.engine.graphics.entities.PhysicsEntity;
import celery.engine.utils.math.Vec2F;

public class CollisionConstraint implements PhysicsConstraint {

	protected SceneEntity ent_;
	protected Vec2F temp_ = new Vec2F(), temp_2 = new Vec2F();;

	public CollisionConstraint(SceneEntity e) {
		ent_ = e;
	}

	@Override
	public boolean applyConstraint(PhysicsEntity e, float timeElapsed) {

		// if (e.entity.isCollision(ent_)) {
		// // compute velocity
		// float l = temp_.set(e.previousPosition)
		// .subEq(e.entity.transform().translate).length();
		//
		// e.entity.transform().translate.addEq(e.entity.geometryData()
		// .minVectorOfCollision());
		// e.previousPosition.set(e.entity.transform().translate).subEq(
		// temp_.set(e.entity.geometryData().minVectorOfCollision())
		// .normalize().scaleEq(l));
		// return true;
		//
		// }

		if (e.entity.isCollision(ent_)) {
			// compute velocity
			// float l = temp_.set(e.entity.transform().translate)
			// .subEq(e.previousPosition).length();

			// if the collision is heading towards us, reflect the output dir
			float l0 = e.entity.transform().translate.distance2(ent_
					.transform().translate);
			float l1 = e.previousPosition.distance2(ent_.transform().translate);
			float l = temp_.set(e.previousPosition)
					.subEq(e.entity.transform().translate).length();
			if (l0 < l1) {
				// v
				temp_.set(e.entity.transform().translate).subEq(
						e.previousPosition);

				// n
				temp_2.set(e.entity.geometryData().minVectorOfCollision())
						.normalize();

				temp_2.scaleEq(temp_2.dot(temp_) * 2.f).subEq(temp_);

				e.entity.transform().translate.addEq(e.entity.geometryData()
						.minVectorOfCollision());
				e.previousPosition.set(e.entity.transform().translate).addEq(
						temp_2);
				return true;
			} else {

				e.entity.transform().translate.addEq(e.entity.geometryData()
						.minVectorOfCollision());
				e.previousPosition.set(e.entity.transform().translate).subEq(
						temp_.set(
								e.entity.geometryData().minVectorOfCollision())
								.normalize().scaleEq(l));
				return true;
			}

		}
		// e.entity.setMaterial(MaterialManager.instance().material("black"));
		return true;
	}
}
