package celery.engine.updatehandlers;

import celery.engine.graphics.entities.PhysicsEntity;
import celery.engine.utils.math.Vec2F;

public class SpringConstraint implements PhysicsConstraint {
	protected PhysicsEntity ent_;
	protected float constraintDist_;
	StickConstraint consMin, consMax;

	public SpringConstraint(PhysicsEntity e, float constraintDist) {
		ent_ = e;
		constraintDist_ = constraintDist;
	}

	public SpringConstraint(PhysicsEntity e, float constraintDist,
			float mindist, float maxdist) {
		ent_ = e;
		constraintDist_ = constraintDist;
		mindist_ = mindist;
		maxdist_ = maxdist;
		consMin = new StickConstraint(e, mindist);
		consMax = new StickConstraint(e, maxdist);
		hasmindist = true;
	}

	float mindist_, maxdist_;
	boolean hasmindist = false;

	Vec2F offset_ = new Vec2F(), dist_ = new Vec2F();
	Vec2F v1_ = new Vec2F(), v2_ = new Vec2F();

	@Override
	public boolean applyConstraint(PhysicsEntity e, float timeElapsed) {
		offset_.set(ent_.entity.transform().translate)
				.subEq(e.entity.transform().translate).normalize();

		float dist = e.entity.transform().translate.distance(ent_.entity
				.transform().translate);

		if (hasmindist && dist < mindist_) {
			consMin.applyConstraint(e, timeElapsed);
		} else if (hasmindist && dist > maxdist_) {
			consMax.applyConstraint(e, timeElapsed);
		}

		dist = (dist - constraintDist_);
		offset_.scaleEq(dist * 5.f);

		ent_.accelAccum.addEq((offset_).scaleEq(-1.f));
		// e.accelAccum.addEq(offset_);

		// ent_.entity.transform().translate.subEq(offset_);
		// e.entity.transform().translate.addEq(offset_);
		// ent_.previousPosition.subEq(offset_);
		// e.previousPosition.addEq(offset_);
		return true;
	}
}
