package celery.engine.updatehandlers;

import celery.engine.graphics.entities.PhysicsEntity;
import celery.engine.utils.math.Vec2F;

public class StickConstraint implements PhysicsConstraint {
	protected PhysicsEntity ent_;
	protected float constraintDist_;

	public StickConstraint(PhysicsEntity e, float constraintDist) {
		ent_ = e;
		constraintDist_ = constraintDist;
	}

	Vec2F offset_ = new Vec2F(), dist_ = new Vec2F();
	Vec2F v1_ = new Vec2F(), v2_ = new Vec2F();

	@Override
	public boolean applyConstraint(PhysicsEntity e, float timeElapsed) {
		offset_.set(ent_.entity.transform().translate)
				.subEq(e.entity.transform().translate).normalize();
		float dist = e.entity.transform().translate.distance(ent_.entity
				.transform().translate);

		dist = (dist - constraintDist_) / 2.f;
		offset_.scaleEq(dist);
		ent_.entity.transform().translate.subEq(offset_);
		e.entity.transform().translate.addEq(offset_);
		ent_.previousPosition.subEq(offset_);
		e.previousPosition.addEq(offset_);
		return true;
	}
}
