package celery.engine.updatehandlers;

import android.os.Message;

/**
 * EngineUpdateHandlers are logical events which must be updated at regular
 * rates. This includes (for example, game logic, physics, drawing, and perhaps
 * sound effects)
 * 
 * @author psastras
 * 
 */

public interface UpdateHandler {

	public abstract void pause();

	public abstract void start();

	public abstract void resume();

	public abstract void stop();

	public abstract void receiveMessage(Message msg);
}
