package celery.engine.updatehandlers;

import celery.engine.Engine;
import celery.engine.graphics.entities.PhysicsEntity;
import celery.engine.utils.math.Vec2F;

public class WallConstraint implements PhysicsConstraint {
	protected int side_ = 0;
	protected float margin_ = 0.f;

	public WallConstraint(int side, float margin) {
		side_ = side;
		margin_ = margin;
	}

	@Override
	public boolean applyConstraint(PhysicsEntity e, float timeElapsed) {
		boolean toReturn = true;
		// e.previousPosition = new Vec2F(e.entity.transform().translate);
		Vec2F pos = e.entity.transform().translate;
		if (side_ == 3 && pos.x < margin_) {
			e.previousPosition = new Vec2F(e.entity.transform().translate);
			pos.x = margin_;
			toReturn = false;
		}
		if (side_ == 1
				&& pos.x > Engine.instance().drawHandler().viewport().bounds().x
						- margin_) {
			e.previousPosition = new Vec2F(e.entity.transform().translate);
			pos.x = Engine.instance().drawHandler().viewport().bounds().x
					- margin_;
			toReturn = false;
		}
		if (side_ == 0 && pos.y < margin_) {
			e.previousPosition = new Vec2F(e.entity.transform().translate);
			pos.y = margin_;
			toReturn = false;
		}
		if (side_ == 2
				&& pos.y > Engine.instance().drawHandler().viewport().bounds().y
						- margin_) {
			e.previousPosition = new Vec2F(e.entity.transform().translate);
			pos.y = Engine.instance().drawHandler().viewport().bounds().y
					- margin_;

			toReturn = false;
		}

		return toReturn;
	}
}
