package celery.engine.utils;

import celery.engine.utils.math.Transform;
import celery.engine.utils.math.Vec2F;

public final class Utils {

	public static final float PI = 3.14159265f;
	public static final float PI180 = 0.0174532925f;
	public static final float PI180I = 57.2957795f;
	public static final Vec2F HALFVEC = new Vec2F(0.5f, 0.5f);

	public static final float toRadians(float degrees) {
		return degrees * PI180;
	}

	public static final float toDegrees(float radians) {
		return radians * PI180I;
	}

	public static final float max(float x, float y) {
		return x > y ? x : y;
	}

	public static final float min(float x, float y) {
		return x < y ? x : y;
	}

	public static final Vec2F toModelSpace(final Transform tfo,
			final Vec2F coord) {
		return (temp.set(coord).rotateCWEq(tfo.translate, tfo.theta)
				.subEq(tfo.translate).divEq(tfo.scale));
	}

	protected static Vec2F temp = new Vec2F();

	public static final Vec2F toWorldSpace(final Transform tfo,
			final Vec2F coord) {
		return temp.set(coord).mulEq(tfo.scale).addEq(tfo.translate)
				.rotateCWEq(tfo.translate, -tfo.theta);

	}

}
