package celery.engine.utils.math;

/**
 * Defines a transform (scale, translation, rotation).
 * 
 * @author psastras
 * 
 */

public final class Transform {

	public float theta; // rotation cw
	public Vec2F translate;
	public Vec2F scale;

	public Transform(float rot, Vec2F t, Vec2F s) {
		theta = rot;
		translate = new Vec2F(t);
		scale = new Vec2F(s);
	}

	public Transform(Transform t) {
		theta = t.theta;
		translate = new Vec2F(t.translate);
		scale = new Vec2F(t.scale);
	}

	public final Transform compose(Transform rhs) {
		theta += rhs.theta;
		translate.addEq(rhs.translate);
		scale.mulEq(rhs.scale);
		return this;
	}
}
