package pathplanner;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map.Entry;

import celery.engine.utils.math.Vec2F;

public class PathNode {

	protected Vec2F position_ = new Vec2F();

	protected HashMap<PathNode, Float> neighbors_ = new HashMap<PathNode, Float>();

	public PathNode(Vec2F pos) {
		position_.set(pos);
	}

	public void addDirectedLink(PathNode neighbor, float cost) {
		neighbors_.put(neighbor, cost);
	}

	public void addBidirectionalLink(PathNode neighbor, float cost) {
		neighbors_.put(neighbor, cost);
		neighbor.addDirectedLink(this, cost);
	}

	public Iterator<Entry<PathNode, Float>> neighbors() {
		return neighbors_.entrySet().iterator();
	}

	public void removeLink(PathNode node) {
		if (neighbors_.containsKey(node)) {
			neighbors_.remove(node);
		}
		node.removeLink(this);
	}

}
